package xyz.lychee.lagfixer.libs.adventure.text.minimessage.internal.parser.node;

import java.util.Objects;
import xyz.lychee.lagfixer.libs.adventure.text.minimessage.internal.parser.Token;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public abstract class ValueNode extends ElementNode {
   private final String value;

   ValueNode(final @Nullable ElementNode parent, final @Nullable Token token, final @NotNull String sourceMessage, final @NotNull String value) {
      super(parent, token, sourceMessage);
      this.value = value;
   }

   abstract String valueName();

   public @NotNull String value() {
      return this.value;
   }

   public @NotNull Token token() {
      return (Token)Objects.requireNonNull(super.token(), "token is not set");
   }

   public @NotNull StringBuilder buildToString(final @NotNull StringBuilder sb, final int indent) {
      char[] in = this.ident(indent);
      sb.append(in).append(this.valueName()).append("('").append(this.value).append("')\n");
      return sb;
   }
}
